## ros-one-coal 3.0.2-423jammy.20260227.2040

=== CMakeLists.txt ===
#
# Software License Agreement (BSD License)
#
# Copyright (c) 2014-2025 CNRS-LAAS, INRIA Author: Florent Lamiraux, Joseph
# Mirabel All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright notice, this
#   list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright notice,
#   this list of conditions and the following disclaimer in the documentation
#   and/or other materials provided with the distribution.
# * Neither the name of CNRS-LAAS. nor the names of its contributors may be used
#   to endorse or promote products derived from this software without specific
#   prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

cmake_minimum_required(VERSION 3.22)
set(CXX_DISABLE_WERROR TRUE)

set(PROJECT_NAME coal)
set(PROJECT_ORG "coal-library")
set(
  PROJECT_DESCRIPTION
  "Coal, The Collision Detection Library. Previously known as HPP-FCL, fork of FCL -- The Flexible Collision Library"
)
set(PROJECT_URL "https://github.com/coal-library/coal")
if(NOT BUILD_STANDALONE_PYTHON_INTERFACE)
  set(PROJECT_USE_CMAKE_EXPORT TRUE)
endif()
set(PROJECT_COMPATIBILITY_VERSION AnyNewerVersion)
# To enable jrl-cmakemodules compatibility with workspace we must define the two
# following lines
set(PROJECT_AUTO_RUN_FINALIZE FALSE)
set(PROJECT_SOURCE_DIR ${CMAKE_CURRENT_LIST_DIR})

set(PROJECT_USE_KEYWORD_LINK_LIBRARIES TRUE)
set(DOXYGEN_USE_TEMPLATE_CSS TRUE)

# ----------------------------------------------------
# --- OPTIONS  ---------------------------------------
# Need to be set before including base.cmake
# ----------------------------------------------------
option(INSTALL_DOCUMENTATION "Generate and install the documentation" OFF)
option(SUFFIX_SO_VERSION "Suffix library name with its version" OFF)
option(
  COAL_TURN_ASSERT_INTO_EXCEPTION
  "Turn some critical Coal asserts to exception."
  FALSE
)
option(
  COAL_ENABLE_LOGGING
  "Activate logging for warnings or error messages. Turned on by default in Debug."
  FALSE
)
option(
  COAL_BACKWARD_COMPATIBILITY_WITH_HPP_FCL
  "Make Coal retro-compatible with HPP-FCL."
  FALSE
)
option(
  COAL_USE_FLOAT_PRECISION
  "Use float precision (32-bit) instead of the default double precision (64-bit)"
  FALSE
)
option(
  COAL_BUILD_WITH_TRACY
  "Build with tracy profiler for performance analysis"
  FALSE
)

# Check if the submodule cmake have been initialized
set(JRL_CMAKE_MODULES "${CMAKE_CURRENT_LIST_DIR}/cmake")
if(EXISTS "${JRL_CMAKE_MODULES}/base.cmake")
  message(STATUS "JRL cmakemodules found in 'cmake/' git submodule")
else()
  find_package(jrl-cmakemodules QUIET CONFIG)
  if(jrl-cmakemodules_FOUND)
    get_property(
      JRL_CMAKE_MODULES
      TARGET jrl-cmakemodules::jrl-cmakemodules
      PROPERTY INTERFACE_INCLUDE_DIRECTORIES
    )
    message(STATUS "JRL cmakemodules found on system at ${JRL_CMAKE_MODULES}")
  else()
    message(STATUS "JRL cmakemodules not found. Let's fetch it.")
    include(FetchContent)
    FetchContent_Declare(
      "jrl-cmakemodules"
      GIT_REPOSITORY "https://github.com/jrl-umi3218/jrl-cmakemodules.git"
    )
    FetchContent_MakeAvailable("jrl-cmakemodules")
    FetchContent_GetProperties("jrl-cmakemodules" SOURCE_DIR JRL_CMAKE_MODULES)
  endif()
endif()

# Use BoostConfig module distributed by boost library instead of using FindBoost
# module distributed by CMake. There is one unresolved issue with FindBoost and
# clang-cl so we deactivate it in this case.
if(NOT WIN32 OR NOT ${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
  if(POLICY CMP0167)
    cmake_policy(SET CMP0167 NEW)
    # Set a default value to this policy to avoid issue with find_dependency
    # macro redefinition with different policy in some modules.
    set(CMAKE_POLICY_DEFAULT_CMP0167 NEW)
  endif()
endif()

include("${JRL_CMAKE_MODULES}/base.cmake")
COMPUTE_PROJECT_ARGS(PROJECT_ARGS LANGUAGES CXX)
project(${PROJECT_NAME} ${PROJECT_ARGS})

include("${JRL_CMAKE_MODULES}/boost.cmake")
include("${JRL_CMAKE_MODULES}/python.cmake")
include("${JRL_CMAKE_MODULES}/apple.cmake")
include("${JRL_CMAKE_MODULES}/ide.cmake")
include("${JRL_CMAKE_MODULES}/tracy.cmake")
include(CMakeDependentOption)

set(
  CMAKE_MODULE_PATH
  ${JRL_CMAKE_MODULES}/find-external/assimp/
  ${CMAKE_MODULE_PATH}
)

function(set_standard_output_directory target)
  set_target_properties(
    ${target}
    PROPERTIES
      RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin
      LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib
      ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib
  )
endfunction()

SET_DEFAULT_CMAKE_BUILD_TYPE("RelWithDebInfo")

# If needed, fix CMake policy for APPLE systems
APPLY_DEFAULT_APPLE_CONFIGURATION()

cmake_dependent_option(
  COAL_PYTHON_NANOBIND
  "Build the nanobind-based bindings."
  OFF
  BUILD_PYTHON_INTERFACE
  OFF
)
# Stubs only optional for legacy Boost.Python bindings
if(NOT COAL_PYTHON_NANOBIND)
  cmake_dependent_option(
    GENERATE_PYTHON_STUBS
    "Generate the Python stubs for the Python bindings (only for legacy Boost.Python bindings)"
    OFF
    BUILD_PYTHON_INTERFACE
    OFF
  )
endif()

ADD_PROJECT_DEPENDENCY(Eigen3 REQUIRED PKG_CONFIG_REQUIRES "eigen3 >= 3.0.0")

# -- tracy profiling (optional)
if(COAL_BUILD_WITH_TRACY)
  # assume it is installed somewhere
  ADD_PROJECT_DEPENDENCY(Tracy REQUIRED)
  set_target_properties(
    Tracy::TracyClient
    PROPERTIES POSITION_INDEPENDENT_CODE True
  )
endif(COAL_BUILD_WITH_TRACY)

# Required dependencies
SET_BOOST_DEFAULT_OPTIONS()
EXPORT_BOOST_DEFAULT_OPTIONS()
ADD_PROJECT_DEPENDENCY(Boost REQUIRED serialization filesystem)
if(COAL_ENABLE_LOGGING)
  ADD_PROJECT_DEPENDENCY(Boost REQUIRED log)
endif()

if(Boost_VERSION_STRING VERSION_LESS 1.81)
  # Default C++ version should be C++11
  CHECK_MINIMAL_CXX_STANDARD(11 ENFORCE)
else()
  # Boost.Math will be C++14 starting in July 2023 (Boost 1.82 release)
  CHECK_MINIMAL_CXX_STANDARD(14 ENFORCE)
endif()

# Optional dependencies
ADD_PROJECT_DEPENDENCY(octomap 1.8.0 PKG_CONFIG_REQUIRES "octomap >= 1.8")
if(octomap_FOUND)
  set(COAL_HAS_OCTOMAP TRUE)
  string(REPLACE "." ";" VERSION_LIST ${octomap_VERSION})
  list(GET VERSION_LIST 0 OCTOMAP_MAJOR_VERSION)
  list(GET VERSION_LIST 1 OCTOMAP_MINOR_VERSION)
  list(GET VERSION_LIST 2 OCTOMAP_PATCH_VERSION)
  message(STATUS "COAL uses Octomap")
else()
  set(COAL_HAS_OCTOMAP FALSE)
  message(STATUS "COAL does not use Octomap")
endif()

option(COAL_HAS_QHULL "use qhull library to compute convex hulls." FALSE)
if(COAL_HAS_QHULL)
  find_package(Qhull REQUIRED COMPONENTS qhull_r qhullcpp)
endif()

find_package(assimp REQUIRED)

set(
  ${PROJECT_NAME}_HEADERS
  include/coal/alloca.h
  include/coal/collision_data.h
  include/coal/BV/kIOS.h
  include/coal/BV/BV.h
  include/coal/BV/RSS.h
  include/coal/BV/OBBRSS.h
  include/coal/BV/BV_node.h
  include/coal/BV/AABB.h
  include/coal/BV/OBB.h
  include/coal/BV/kDOP.h
  include/coal/broadphase/broadphase.h
  include/coal/broadphase/broadphase_SSaP.h
  include/coal/broadphase/broadphase_SaP.h
  include/coal/broadphase/broadphase_bruteforce.h
  include/coal/broadphase/broadphase_collision_manager.h
  include/coal/broadphase/broadphase_continuous_collision_manager-inl.h
  include/coal/broadphase/broadphase_continuous_collision_manager.h
  include/coal/broadphase/broadphase_dynamic_AABB_tree-inl.h
  include/coal/broadphase/broadphase_dynamic_AABB_tree.h
  include/coal/broadphase/broadphase_dynamic_AABB_tree_array-inl.h
  include/coal/broadphase/broadphase_dynamic_AABB_tree_array.h
  include/coal/broadphase/broadphase_interval_tree.h
  include/coal/broadphase/broadphase_spatialhash-inl.h
  include/coal/broadphase/broadphase_spatialhash.h
  include/coal/broadphase/broadphase_callbacks.h
  include/coal/broadphase/default_broadphase_callbacks.h
  include/coal/broadphase/detail/hierarchy_tree-inl.h
  include/coal/broadphase/detail/hierarchy_tree.h
  include/coal/broadphase/detail/hierarchy_tree_array-inl.h
  include/coal/broadphase/detail/hierarchy_tree_array.h
  include/coal/broadphase/detail/interval_tree.h
  include/coal/broadphase/detail/interval_tree_node.h
  include/coal/broadphase/detail/morton-inl.h
  include/coal/broadphase/detail/morton.h
  include/coal/broadphase/detail/node_base-inl.h
  include/coal/broadphase/detail/node_base.h
  include/coal/broadphase/detail/node_base_array-inl.h
  include/coal/broadphase/detail/node_base_array.h
  include/coal/broadphase/detail/simple_hash_table-inl.h
  include/coal/broadphase/detail/simple_hash_table.h
  include/coal/broadphase/detail/simple_interval-inl.h
  include/coal/broadphase/detail/simple_interval.h
  include/coal/broadphase/detail/sparse_hash_table-inl.h
  include/coal/broadphase/detail/sparse_hash_table.h
  include/coal/broadphase/detail/spatial_hash-inl.h
  include/coal/broadphase/detail/spatial_hash.h
  include/coal/narrowphase/narrowphase.h
  include/coal/narrowphase/gjk.h
  include/coal/narrowphase/narrowphase_defaults.h
  include/coal/narrowphase/minkowski_difference.h
  include/coal/narrowphase/support_data.h
  include/coal/narrowphase/support_functions.h
  include/coal/shape/convex.h
  include/coal/shape/convex.hxx
  include/coal/shape/geometric_shape_to_BVH_model.h
  include/coal/shape/geometric_shapes.h
  include/coal/shape/geometric_shapes.hxx
  include/coal/shape/geometric_shapes_traits.h
  include/coal/shape/geometric_shapes_utility.h
  include/coal/distance_func_matrix.h
  include/coal/collision.h
  include/coal/collision_func_matrix.h
  include/coal/contact_patch.h
  include/coal/contact_patch_func_matrix.h
  include/coal/contact_patch/contact_patch_solver.h
  include/coal/contact_patch/contact_patch_solver.hxx
  include/coal/contact_patch/contact_patch_simplifier.h
  include/coal/contact_patch/polygon_convex_hull.h
  include/coal/distance.h
  include/coal/math/matrix_3f.h
  include/coal/math/vec_3f.h
  include/coal/math/types.h
  include/coal/math/transform.h
  include/coal/data_types.h
  include/coal/BVH/BVH_internal.h
  include/coal/BVH/BVH_model.h
  include/coal/BVH/BVH_front.h
  include/coal/BVH/BVH_utility.h
  include/coal/collision_object.h
  include/coal/collision_utility.h
  include/coal/hfield.h
  include/coal/fwd.hh
  include/coal/logging.h
  include/coal/mesh_loader/assimp.h
  include/coal/mesh_loader/loader.h
  include/coal/internal/BV_fitter.h
  include/coal/internal/BV_splitter.h
  include/coal/internal/shape_shape_func.h
  include/coal/internal/shape_shape_contact_patch_func.h
  include/coal/internal/intersect.h
  include/coal/internal/intersect.hxx
  include/coal/internal/tools.h
  include/coal/internal/traversal_node_base.h
  include/coal/internal/traversal_node_bvh_shape.h
  include/coal/internal/traversal_node_bvhs.h
  include/coal/internal/traversal_node_hfield_shape.h
  include/coal/internal/traversal_node_setup.h
  include/coal/internal/traversal_node_shapes.h
  include/coal/internal/traversal_recurse.h
  include/coal/internal/traversal.h
  include/coal/serialization/fwd.h
  include/coal/serialization/serializer.h
  include/coal/serialization/archive.h
  include/coal/serialization/transform.h

=== cmake/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22)

set(PROJECT_NAME "jrl-cmakemodules")
set(PROJECT_DESCRIPTION "CMake utility toolbox")
set(PROJECT_URL "http://github.com/jrl-umi3218/${PROJECT_NAME}")

project(${PROJECT_NAME} DESCRIPTION ${PROJECT_DESCRIPTION} LANGUAGES CXX)

# Avoid project to be installed when it's not the top-level cmake.
# First detect super project, second one detect fetch content.
# The seconde one is needed because jrl-cmakemodules are included
# before top-level cmake project definition.
if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME AND NOT ${PROJECT_NAME}_POPULATED)
  set(PROJECT_JRL_CMAKE_MODULE_DIR ${CMAKE_CURRENT_LIST_DIR})
  include(base.cmake)
  COMPUTE_PROJECT_ARGS(PROJECT_ARGS LANGUAGES CXX)
  project(${PROJECT_NAME} ${PROJECT_ARGS})

  # Add a dummy library with a useful INTERFACE_INCLUDE_DIRECTORIES
  add_library(${PROJECT_NAME} INTERFACE)
  set(INSTALL_DIR "${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME}")
  target_include_directories(
    ${PROJECT_NAME}
    INTERFACE $<INSTALL_INTERFACE:${INSTALL_DIR}>
  )

  # find . -maxdepth 1 -type d ! -path './.*' | sort
  install(
    DIRECTORY
      ./boost
      ./cython
      ./doxygen
      ./dynamic_graph
      ./find-external
      ./github
      ./gtest
      ./hpp
      ./image
      ./sphinx
      ./stubgen
      ./_unittests
    DESTINATION ${INSTALL_DIR}
  )

  # find . -maxdepth 1 -type f ! -perm 111 ! -path './.*' | sort
  install(
    PROGRAMS
      ./announce-gen
      ./fix-license.sh
      ./git-archive-all.py
      ./git-archive-all.sh
      ./gitlog-to-changelog
      ./pixi.py
      ./pyproject.py
    DESTINATION ${INSTALL_DIR}
  )

  # find . -maxdepth 1 -type f ! -perm /111 ! -path './.*' | sort
  install(
    FILES
      ./apple.cmake
      ./base.cmake
      ./boost.cmake
      ./catkin.cmake
      ./CMakeLists.txt
      ./cmake_reinstall.cmake.in
      ./cmake_uninstall.cmake.in
      ./compiler.cmake
      ./componentConfig.cmake.in
      ./Config.cmake.in
      ./config.h.cmake
      ./config.hh.cmake
      ./coverage.cmake
      ./cpack.cmake
      ./createshexe.cmake
      ./cxx11.cmake
      ./cxx-standard.cmake
      ./debian.cmake
      ./deprecated.hh.cmake
      ./distcheck.cmake
      ./dist.cmake
      ./doxygen.cmake
      ./eigen.cmake
      ./filefilter.txt
      ./flake.lock
      ./flake.nix
      ./geometric-tools.cmake
      ./GNUInstallDirs.cmake
      ./gtest.cmake
      ./header.cmake
      ./hpp.cmake
      ./ide.cmake
      ./idl.cmake
      ./idlrtc.cmake
      ./install-data.cmake
      ./install-helpers.cmake
      ./julia.cmake
      ./kineo.cmake
      ./lapack.cmake
      ./LICENSE
      ./logging.cmake
      ./man.cmake
      ./memorycheck_unit_test.cmake.in
      ./metapodfromurdf.cmake
      ./modernize-links.cmake
      ./msvc-specific.cmake
      ./msvc.vcxproj.user.in
      ./openhrp.cmake
      ./openhrpcontroller.cmake
      ./openrtm.cmake
      ./oscheck.cmake
      ./package-config.cmake
      ./package.xml
      ./pkg-config.cmake
      ./pkg-config.pc.cmake
      ./portability.cmake
      ./post-project.cmake
      ./pthread.cmake
      ./python.cmake
      ./python-helpers.cmake
      ./qhull.cmake
      ./README.md
      ./release.cmake
      ./relpath.cmake
      ./ros2.cmake
      ./ros.cmake
      ./sdformat.cmake
      ./setup.cfg
      ./shared-library.cmake
      ./sphinx.cmake
      ./stubs.cmake
      ./swig.cmake
      ./test.cmake
      ./tracy.cmake
      ./tracy.hh.cmake
      ./uninstall.cmake
      ./version.cmake
      ./version-script.cmake
      ./version-script-test.lds
      ./warning.hh.cmake
      ./xacro.cmake
    DESTINATION ${INSTALL_DIR}
  )

  # This package is architecture independent. Dont allow ROS to think otherwise
  # and break everything by installing in lib/x86_64-linux-gnu, which does prevent
  # find_package(jrl-cmakemodules) to work before a call to project().
  # share is fine.
  set(
    CMAKE_INSTALL_LIBDIR
    "${CMAKE_INSTALL_DATAROOTDIR}"
    CACHE PATH
    "Install exports in share, not lib"
    FORCE
  )

  install(TARGETS ${PROJECT_NAME} EXPORT ${TARGETS_EXPORT_NAME})

  SETUP_PROJECT_PACKAGE_FINALIZE()
endif()

=== doc/CMakeLists.txt ===
set(DOXYGEN_XML_OUTPUT "doxygen-xml" PARENT_SCOPE)
set(DOXYGEN_FILE_PATTERNS "*.h  *.hh  *.hxx" PARENT_SCOPE)
set(DOXYGEN_GENERATE_XML "YES" PARENT_SCOPE)
set(DOXYGEN_EXPAND_ONLY_PREDEF "NO" PARENT_SCOPE)
set(DOXYGEN_ENABLE_PREPROCESSING "YES" PARENT_SCOPE)
set(DOXYGEN_MACRO_EXPANSION "YES" PARENT_SCOPE)
set(DOXYGEN_EXCLUDE "${PROJECT_SOURCE_DIR}/include/hpp/")

# We must not document octree if Octomap is not setup.
# This create a build issue when building the bindings because doxygen-autodoc will
# include octree.h that will include octomap.h.
if(NOT COAL_HAS_OCTOMAP)
  set(
    DOXYGEN_EXCLUDE
    "${DOXYGEN_EXCLUDE} ${PROJECT_SOURCE_DIR}/include/coal/octree.h"
  )
  set(
    DOXYGEN_EXCLUDE
    "${DOXYGEN_EXCLUDE} ${PROJECT_SOURCE_DIR}/include/coal/serialization/octree.h"
  )
  set(
    DOXYGEN_EXCLUDE
    "${DOXYGEN_EXCLUDE} ${PROJECT_SOURCE_DIR}/include/coal/internal/traversal_node_octree.h"
  )
endif()
set(DOXYGEN_EXCLUDE ${DOXYGEN_EXCLUDE} PARENT_SCOPE)

set(DOXYGEN_PREDEFINED "IS_DOXYGEN" PARENT_SCOPE)

=== python-nb/CMakeLists.txt ===
# Copyright 2025 INRIA

# Detect the installed nanobind package and import it into CMake
execute_process(
  COMMAND "${Python_EXECUTABLE}" -m nanobind --cmake_dir
  OUTPUT_STRIP_TRAILING_WHITESPACE
  OUTPUT_VARIABLE nanobind_ROOT
)
# Honor nanobind_ROOT
cmake_policy(PUSH)
cmake_policy(SET CMP0074 NEW)
find_package(nanobind CONFIG REQUIRED)
cmake_policy(POP)
find_package(Boost REQUIRED)

# Nanoeigenpy
find_package(nanoeigenpy CONFIG REQUIRED)

set(PYTHON_LIB_NAME_V2 ${PROJECT_NAME}_pywrap_nb)

# Headers
set(
  PYTHON_LIB_HEADERS
  broadphase/broadphase_callbacks_collision_manager.hh
  fwd.h
  pickle.hh
  serializable.hh
)

# Sources
set(
  PYTHON_LIB_SOURCES
  broadphase/broadphase.cc
  aabb.cc
  bvh.cc
  collision-geometries.cc
  collision.cc
  contact_patch.cc
  distance.cc
  math.cc
  gjk.cc
  height_field.cc
  memory-footprint.cc
  shapes.cc
  module.cc
)
if(COAL_HAS_OCTOMAP)
  list(APPEND PYTHON_LIB_SOURCES octree.cc)
endif(COAL_HAS_OCTOMAP)

nanobind_add_module(${PYTHON_LIB_NAME_V2} NB_STATIC LTO NB_SUPPRESS_WARNINGS ${PYTHON_LIB_SOURCES})
target_link_libraries(
  ${PYTHON_LIB_NAME_V2}
  PRIVATE ${PROJECT_NAME}::${PROJECT_NAME} Boost::boost
)
target_compile_definitions(
  ${PYTHON_LIB_NAME_V2}
  PRIVATE COAL_PYTHON_LIBNAME=${PYTHON_LIB_NAME_V2}
)

set(MODULE_DIR ${PROJECT_NAME})

set_target_properties(
  ${PYTHON_LIB_NAME_V2}
  PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/${MODULE_DIR}"
)

set(PYTHON_LIB_STUB_FILE ${MODULE_DIR}/${PYTHON_LIB_NAME_V2}.pyi)

nanobind_add_stub(
  ${PYTHON_LIB_NAME_V2}_stub
  VERBOSE
  MODULE ${PROJECT_NAME}.${PYTHON_LIB_NAME_V2}
  OUTPUT ${PYTHON_LIB_STUB_FILE}
  DEPENDS ${PYTHON_LIB_NAME_V2}
  PYTHON_PATH ${CMAKE_CURRENT_BINARY_DIR}/${MODULE_DIR}
)
add_dependencies(${PROJECT_NAME}_python ${PYTHON_LIB_NAME_V2})
ADD_SOURCE_GROUP(PYTHON_LIB_SOURCES)

set(PYTHON_FILES __init__.py windows_dll_manager.py)
foreach(pyfile ${PYTHON_FILES})
  message(STATUS "Building python file ${pyfile}")
  PYTHON_BUILD(${MODULE_DIR} ${pyfile})
  install(
    FILES ${MODULE_DIR}/${pyfile}
    DESTINATION ${Python_SITELIB}/${MODULE_DIR}
  )
endforeach(pyfile)

install(
  TARGETS ${PYTHON_LIB_NAME_V2}
  EXPORT ${TARGETS_EXPORT_NAME}
  LIBRARY DESTINATION ${Python_SITELIB}/${MODULE_DIR}
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/${PYTHON_LIB_STUB_FILE}
  DESTINATION ${Python_SITELIB}/${MODULE_DIR}
)

=== python/CMakeLists.txt ===
#
# Software License Agreement (BSD License)
#
#  Copyright (c) 2019-2023 CNRS-LAAS INRIA
#  Author: Joseph Mirabel
#  All rights reserved.
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions
#  are met:
#
#   * Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   * Redistributions in binary form must reproduce the above
#     copyright notice, this list of conditions and the following
#     disclaimer in the documentation and/or other materials provided
#     with the distribution.
#   * Neither the name of CNRS-LAAS. nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
#  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
#  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
#  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
#  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
#  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
#  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
#  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
#  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
#  POSSIBILITY OF SUCH DAMAGE.
find_package(Boost REQUIRED)

if(GENERATE_PYTHON_STUBS)
  include(${JRL_CMAKE_MODULES}/stubs.cmake)
endif(GENERATE_PYTHON_STUBS)

# Name of the Python library
set(PYTHON_LIB_NAME ${PROJECT_NAME}_pywrap)

set(
  ${PYTHON_LIB_NAME}_HEADERS
  fwd.hh
  coal.hh
  deprecation.hh
  broadphase/fwd.hh
  broadphase/broadphase_collision_manager.hh
  broadphase/broadphase_callbacks.hh
  pickle.hh
  utils/std-pair.hh
  serializable.hh
)

set(
  ENABLE_PYTHON_DOXYGEN_AUTODOC
  TRUE
  CACHE BOOL
  "Enable automatic documentation of Python bindings from Doxygen documentation"
)

if(NOT ENABLE_PYTHON_DOXYGEN_AUTODOC OR NOT DOXYGEN_FOUND)
  set(ENABLE_DOXYGEN_AUTODOC FALSE)
else()
  set(ENABLE_DOXYGEN_AUTODOC TRUE)

  execute_process(
    COMMAND ${PYTHON_EXECUTABLE} -c "import lxml"
    RESULT_VARIABLE _pypkg_found
    OUTPUT_QUIET
    ERROR_QUIET
  )
  if(_pypkg_found EQUAL 0)
    message(STATUS "Found Python package lxml.")
  else()
    set(ENABLE_DOXYGEN_AUTODOC FALSE)
    message(
      STATUS
      "Python package lxml not found. Python bindings will not be documented."
    )
    message(STATUS "  You can install it with: pip install lxml")
  endif()

  execute_process(
    COMMAND ${PYTHON_EXECUTABLE} -c "import pylatexenc"
    RESULT_VARIABLE _pypkg_found
    OUTPUT_QUIET
    ERROR_QUIET
  )
  if(NOT _pypkg_found EQUAL 0)
    message(STATUS "Python package pylatexenc not found.")
    message(
      STATUS
      "  Formulas in the Python bindings documentation may look ugly."
    )
    message(STATUS "  You can install it with: pip install pylatexenc")
  endif()
  unset(_pypkg_found)
endif()
if(ENABLE_DOXYGEN_AUTODOC)
  add_custom_target(
    generate_doxygen_cpp_doc
    COMMAND
      ${PYTHON_EXECUTABLE}
      ${PROJECT_SOURCE_DIR}/doc/python/doxygen_xml_parser.py
      ${PROJECT_BINARY_DIR}/doc/doxygen-xml/index.xml
      ${CMAKE_CURRENT_BINARY_DIR}/doxygen_autodoc >
      ${CMAKE_CURRENT_BINARY_DIR}/doxygen_autodoc.log
    BYPRODUCTS
      ${CMAKE_CURRENT_BINARY_DIR}/doxygen_autodoc/doxygen_xml_parser_for_cmake.hh
      ${CMAKE_CURRENT_BINARY_DIR}/doxygen_autodoc.log
    COMMENT "Generating Doxygen C++ documentation"
  )
  add_dependencies(generate_doxygen_cpp_doc doc)

  list(
    APPEND ${PYTHON_LIB_NAME}_HEADERS
    ${CMAKE_CURRENT_BINARY_DIR}/doxygen_autodoc/doxygen_xml_parser_for_cmake.hh
  )
endif()

set(
  ${PYTHON_LIB_NAME}_SOURCES
  version.cc
  math.cc
  collision-geometries.cc
  collision.cc
  contact_patch.cc
  distance.cc
  coal.cc
  gjk.cc
  broadphase/broadphase.cc
)

if(COAL_HAS_OCTOMAP)
  list(APPEND ${PYTHON_LIB_NAME}_SOURCES octree.cc)
endif(COAL_HAS_OCTOMAP)

add_library(
  ${PYTHON_LIB_NAME}
  MODULE
  ${${PYTHON_LIB_NAME}_SOURCES}
  ${${PYTHON_LIB_NAME}_HEADERS}
)
target_include_directories(
  ${PYTHON_LIB_NAME}
  SYSTEM
  PRIVATE ${PYTHON_INCLUDE_DIRS}
)
target_include_directories(
  ${PYTHON_LIB_NAME}
  PRIVATE "${PROJECT_SOURCE_DIR}/src" "${CMAKE_CURRENT_BINARY_DIR}"
)
if(WIN32)
  target_link_libraries(${PYTHON_LIB_NAME} PUBLIC ${PYTHON_LIBRARY})
endif(WIN32)

add_dependencies(${PROJECT_NAME}_python ${PYTHON_LIB_NAME})
ADD_HEADER_GROUP(${PYTHON_LIB_NAME}_HEADERS)
ADD_SOURCE_GROUP(${PYTHON_LIB_NAME}_SOURCES)
if(ENABLE_DOXYGEN_AUTODOC)
  add_dependencies(${PYTHON_LIB_NAME} generate_doxygen_cpp_doc)
  target_compile_definitions(
    ${PYTHON_LIB_NAME}
    PRIVATE COAL_HAS_DOXYGEN_AUTODOC
  )
endif()

target_link_libraries(
  ${PYTHON_LIB_NAME}
  PUBLIC ${PROJECT_NAME}::${PROJECT_NAME} eigenpy::eigenpy Boost::boost
)

set_target_properties(
  ${PYTHON_LIB_NAME}
  PROPERTIES
    PREFIX ""
    SUFFIX "${PYTHON_EXT_SUFFIX}"
    OUTPUT_NAME "${PYTHON_LIB_NAME}"
    LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/python/${PROJECT_NAME}"
    # On Windows, shared library are treat as binary
    RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/python/${PROJECT_NAME}"
)

if(IS_ABSOLUTE ${PYTHON_SITELIB})
  set(ABSOLUTE_PYTHON_SITELIB ${PYTHON_SITELIB})
else()
  set(ABSOLUTE_PYTHON_SITELIB ${CMAKE_INSTALL_PREFIX}/${PYTHON_SITELIB})
endif()
set(${PYTHON_LIB_NAME}_INSTALL_DIR ${ABSOLUTE_PYTHON_SITELIB}/${PROJECT_NAME})
if(UNIX)
  GET_RELATIVE_RPATH(
    ${${PYTHON_LIB_NAME}_INSTALL_DIR}
    ${PYTHON_LIB_NAME}_INSTALL_RPATH
  )
  set_target_properties(
    ${PYTHON_LIB_NAME}
    PROPERTIES INSTALL_RPATH "${${PYTHON_LIB_NAME}_INSTALL_RPATH}"
  )
endif()

install(
  TARGETS ${PYTHON_LIB_NAME}
  EXPORT ${TARGETS_EXPORT_NAME}
  DESTINATION ${${PYTHON_LIB_NAME}_INSTALL_DIR}
)

# --- GENERATE STUBS
if(GENERATE_PYTHON_STUBS)
  LOAD_STUBGEN()
  GENERATE_STUBS(
    ${CMAKE_CURRENT_BINARY_DIR}
    ${PROJECT_NAME}
    ${ABSOLUTE_PYTHON_SITELIB}
    ${PYTHON_LIB_NAME}
    ${PROJECT_NAME}::${PROJECT_NAME}
  )
endif(GENERATE_PYTHON_STUBS)

# --- INSTALL SCRIPTS
set(PYTHON_FILES __init__.py viewer.py windows_dll_manager.py)

foreach(python ${PYTHON_FILES})
  PYTHON_BUILD(${PROJECT_NAME} ${python})
  install(
    FILES "${CMAKE_CURRENT_SOURCE_DIR}/${PROJECT_NAME}/${python}"
    DESTINATION ${${PYTHON_LIB_NAME}_INSTALL_DIR}
  )
endforeach(python)

if(COAL_BACKWARD_COMPATIBILITY_WITH_HPP_FCL)
  PYTHON_INSTALL_ON_SITE(hppfcl __init__.py COMPONENT hpp-fcl-compatibility)
  PYTHON_INSTALL_ON_SITE(hppfcl viewer.py COMPONENT hpp-fcl-compatibility)
endif()

=== src/CMakeLists.txt ===
#
# Software License Agreement (BSD License)
#
#  Copyright (c) 2014, 2020-2024 CNRS-LAAS INRIA
#  Author: Florent Lamiraux
#  All rights reserved.
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions
#  are met:
#
#   * Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   * Redistributions in binary form must reproduce the above
#     copyright notice, this list of conditions and the following
#     disclaimer in the documentation and/or other materials provided
#     with the distribution.
#   * Neither the name of CNRS-LAAS. nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
#  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
#  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
#  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
#  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
#  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
#  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
#  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
#  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
#  POSSIBILITY OF SUCH DAMAGE.

set(LIBRARY_NAME ${PROJECT_NAME})
set(
  ${LIBRARY_NAME}_SOURCES
  collision.cpp
  contact_patch.cpp
  contact_patch/contact_patch_solver.cpp
  contact_patch/contact_patch_simplifier.cpp
  contact_patch/polygon_convex_hull.cpp
  contact_patch_func_matrix.cpp
  distance_func_matrix.cpp
  collision_data.cpp
  collision_node.cpp
  collision_object.cpp
  BV/RSS.cpp
  BV/AABB.cpp
  BV/kIOS.cpp
  BV/kDOP.cpp
  BV/OBBRSS.cpp
  BV/OBB.cpp
  broadphase/default_broadphase_callbacks.cpp
  broadphase/broadphase_dynamic_AABB_tree.cpp
  broadphase/broadphase_dynamic_AABB_tree_array.cpp
  broadphase/broadphase_bruteforce.cpp
  broadphase/broadphase_collision_manager.cpp
  broadphase/broadphase_SaP.cpp
  broadphase/broadphase_SSaP.cpp
  broadphase/broadphase_interval_tree.cpp
  broadphase/detail/interval_tree.cpp
  broadphase/detail/interval_tree_node.cpp
  broadphase/detail/simple_interval.cpp
  broadphase/detail/spatial_hash.cpp
  broadphase/detail/morton.cpp
  narrowphase/gjk.cpp
  narrowphase/minkowski_difference.cpp
  narrowphase/support_functions.cpp
  narrowphase/details.h
  shape/geometric_shapes.cpp
  shape/geometric_shapes_utility.cpp
  distance/box_halfspace.cpp
  distance/box_plane.cpp
  distance/box_sphere.cpp
  distance/capsule_capsule.cpp
  distance/capsule_halfspace.cpp
  distance/capsule_plane.cpp
  distance/cone_halfspace.cpp
  distance/cone_plane.cpp
  distance/cylinder_halfspace.cpp
  distance/cylinder_plane.cpp
  distance/sphere_sphere.cpp
  distance/sphere_cylinder.cpp
  distance/sphere_halfspace.cpp
  distance/sphere_plane.cpp
  distance/sphere_capsule.cpp
  distance/ellipsoid_halfspace.cpp
  distance/ellipsoid_plane.cpp
  distance/convex_halfspace.cpp
  distance/convex_plane.cpp
  distance/triangle_halfspace.cpp
  distance/triangle_plane.cpp
  distance/triangle_triangle.cpp
  distance/triangle_sphere.cpp
  distance/halfspace_plane.cpp
  distance/plane_plane.cpp
  distance/halfspace_halfspace.cpp
  intersect.cpp
  math/transform.cpp
  traversal/traversal_recurse.cpp
  distance.cpp
  BVH/BVH_utility.cpp
  BVH/BV_fitter.cpp
  BVH/BVH_model.cpp
  BVH/BV_splitter.cpp
  collision_func_matrix.cpp
  collision_utility.cpp
  mesh_loader/assimp.cpp
  mesh_loader/loader.cpp
  hfield.cpp
  serialization/serialization.cpp
)

if(COAL_HAS_OCTOMAP)
  list(APPEND ${LIBRARY_NAME}_SOURCES octree.cpp)
endif(COAL_HAS_OCTOMAP)

set(PROJECT_HEADERS_FULL_PATH)
foreach(header ${${PROJECT_NAME}_HEADERS})
  list(APPEND PROJECT_HEADERS_FULL_PATH ${PROJECT_SOURCE_DIR}/${header})
endforeach()
list(
  APPEND PROJECT_HEADERS_FULL_PATH
  ${PROJECT_BINARY_DIR}/include/coal/config.hh
)
list(
  APPEND PROJECT_HEADERS_FULL_PATH
  ${PROJECT_BINARY_DIR}/include/coal/deprecated.hh
)
list(
  APPEND PROJECT_HEADERS_FULL_PATH
  ${PROJECT_BINARY_DIR}/include/coal/warning.hh
)
add_library(
  ${LIBRARY_NAME}
  SHARED
  ${PROJECT_HEADERS_FULL_PATH}
  ${${LIBRARY_NAME}_SOURCES}
)
add_library(${LIBRARY_NAME}::${LIBRARY_NAME} ALIAS ${LIBRARY_NAME})
set_standard_output_directory(${LIBRARY_NAME})

if(COAL_BACKWARD_COMPATIBILITY_WITH_HPP_FCL)
  add_library(hpp-fcl ALIAS ${LIBRARY_NAME})
  add_library(hpp-fcl::hpp-fcl ALIAS ${LIBRARY_NAME})
endif()

if(UNIX)
  GET_RELATIVE_RPATH(${CMAKE_INSTALL_LIBDIR} ${PROJECT_NAME}_INSTALL_RPATH)
  set_target_properties(
    ${PROJECT_NAME}
    PROPERTIES INSTALL_RPATH "${${PROJECT_NAME}_INSTALL_RPATH}"
  )
endif()
if(SUFFIX_SO_VERSION)
  set_target_properties(
    ${PROJECT_NAME}
    PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR}
  )
endif()

CXX_FLAGS_BY_COMPILER_FRONTEND(MSVC "/bigobj" OUTPUT PUBLIC_OPTIONS FILTER)
target_compile_options(${PROJECT_NAME} PUBLIC ${PUBLIC_OPTIONS})

CXX_FLAGS_BY_COMPILER_FRONTEND(MSVC "NOMINMAX" OUTPUT PUBLIC_DEFINITIONS)
target_compile_definitions(${PROJECT_NAME} INTERFACE ${PUBLIC_DEFINITIONS})

# IDE sources and headers sorting
ADD_SOURCE_GROUP(${LIBRARY_NAME}_SOURCES)
ADD_HEADER_GROUP(PROJECT_HEADERS_FULL_PATH)

MODERNIZE_TARGET_LINK_LIBRARIES(
  ${LIBRARY_NAME}
  SCOPE PRIVATE
  TARGETS assimp::assimp
  LIBRARIES ${assimp_LIBRARIES}
  INCLUDE_DIRS ${assimp_INCLUDE_DIR}
)

target_link_libraries(
  ${LIBRARY_NAME}
  PUBLIC Boost::serialization Boost::filesystem
)

if(COAL_ENABLE_LOGGING)
  target_link_libraries(${LIBRARY_NAME} PUBLIC Boost::log)
  # The compile flag `BOOST_LOG_DYN_LINK` is required here.
  target_compile_definitions(
    ${LIBRARY_NAME}
    PUBLIC COAL_ENABLE_LOGGING BOOST_LOG_DYN_LINK
  )
endif()

if(COAL_USE_FLOAT_PRECISION)
  target_compile_definitions(${LIBRARY_NAME} PUBLIC COAL_USE_FLOAT_PRECISION)
endif()

if(COAL_BUILD_WITH_TRACY)
  target_compile_definitions(${LIBRARY_NAME} PUBLIC COAL_TRACY_ENABLE)
  target_link_libraries(${LIBRARY_NAME} PUBLIC Tracy::TracyClient)
endif()

if(WIN32)
  # There is an issue with MSVC 2017 and Eigen (due to std::aligned_storage).
  # See https://github.com/ceres-solver/ceres-solver/issues/481
  target_compile_definitions(
    ${LIBRARY_NAME}
    PRIVATE _ENABLE_EXTENDED_ALIGNED_STORAGE
  )
endif(WIN32)

if(COAL_TURN_ASSERT_INTO_EXCEPTION)
  target_compile_definitions(
    ${LIBRARY_NAME}
    PUBLIC COAL_TURN_ASSERT_INTO_EXCEPTION
  )
endif()

if(COAL_BACKWARD_COMPATIBILITY_WITH_HPP_FCL)
  target_compile_definitions(
    ${LIBRARY_NAME}
    PUBLIC COAL_BACKWARD_COMPATIBILITY_WITH_HPP_FCL
  )
endif()

if(COAL_HAS_QHULL)
  target_compile_definitions(${LIBRARY_NAME} PRIVATE COAL_HAS_QHULL)
  target_link_libraries(${LIBRARY_NAME} PRIVATE Qhull::qhull_r Qhull::qhullcpp)
endif()

MODERNIZE_TARGET_LINK_LIBRARIES(
  ${PROJECT_NAME}
  SCOPE PUBLIC
  TARGETS Eigen3::Eigen
  INCLUDE_DIRS ${EIGEN3_INCLUDE_DIR}
)

target_include_directories(
  ${LIBRARY_NAME}
  PUBLIC
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
)

# boost::span requires Boost >= 1.78.0.
# On Ubuntu 22.04 the system Boost is 1.74 and is too old.
# In this case, we add include/coal/third_party as include directory.
if(Boost_VERSION VERSION_LESS 1.78)
  target_include_directories(
    ${LIBRARY_NAME}
    PUBLIC
      $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/coal/third_party>
      $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/coal/third_party>
  )
endif()

if(octomap_FOUND)
  MODERNIZE_TARGET_LINK_LIBRARIES(
    ${PROJECT_NAME}
    SCOPE PUBLIC
    TARGETS octomap
    LIBRARIES ${OCTOMAP_LIBRARIES}
    INCLUDE_DIRS ${OCTOMAP_INCLUDE_DIRS}
  )
  target_compile_definitions(
    ${LIBRARY_NAME}
    PUBLIC
      COAL_HAS_OCTOMAP
      COAL_HAVE_OCTOMAP
      OCTOMAP_MAJOR_VERSION=${OCTOMAP_MAJOR_VERSION}
      OCTOMAP_MINOR_VERSION=${OCTOMAP_MINOR_VERSION}
      OCTOMAP_PATCH_VERSION=${OCTOMAP_PATCH_VERSION}
  )
endif(octomap_FOUND)

install(
  TARGETS ${LIBRARY_NAME}
  EXPORT ${TARGETS_EXPORT_NAME}
  PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== test/CMakeLists.txt ===
# Find Boost.UnitTestFramework
if(NOT BUILD_STANDALONE_PYTHON_INTERFACE)
  find_package(Boost REQUIRED COMPONENTS unit_test_framework filesystem)

  CONFIG_FILES(fcl_resources/config.h)

  function(add_coal_test test_name source)
    set(target_name ${PROJECT_NAME}-${test_name})
    ADD_UNIT_TEST(${target_name} ${source})
    set_standard_output_directory(${target_name})
    target_link_libraries(
      ${target_name}
      PUBLIC ${LIBRARY_NAME} Boost::filesystem ${utility_target}
    )
    CXX_FLAGS_BY_COMPILER_FRONTEND(
      GNU "-Wno-c99-extensions"
      OUTPUT PRIVATE_OPTIONS
    )
    target_compile_options(${target_name} PRIVATE ${PRIVATE_OPTIONS})
    if(COAL_HAS_QHULL)
      target_compile_definitions(${target_name} PRIVATE COAL_HAS_QHULL)
    endif()
  endfunction()

  include_directories(${CMAKE_CURRENT_BINARY_DIR})

  set(utility_target ${PROJECT_NAME}-utility)
  add_library(${utility_target} STATIC utility.cpp)
  set_standard_output_directory(${utility_target})
  target_link_libraries(${utility_target} PUBLIC ${PROJECT_NAME})

  add_coal_test(math math.cpp)

  add_coal_test(collision collision.cpp)
  add_coal_test(contact_patch contact_patch.cpp)
  add_coal_test(distance distance.cpp)
  add_coal_test(swept_sphere_radius swept_sphere_radius.cpp)
  add_coal_test(normal_and_nearest_points normal_and_nearest_points.cpp)
  add_coal_test(distance_lower_bound distance_lower_bound.cpp)
  add_coal_test(security_margin security_margin.cpp)
  add_coal_test(geometric_shapes geometric_shapes.cpp)
  add_coal_test(shape_inflation shape_inflation.cpp)
  add_coal_test(polygon_convex_hull polygon_convex_hull.cpp)
  add_coal_test(patch_simplifier patch_simplifier.cpp)
  #add_coal_test(shape_mesh_consistency shape_mesh_consistency.cpp)
  add_coal_test(gjk_asserts gjk_asserts.cpp)
  add_coal_test(frontlist frontlist.cpp)
  set_tests_properties(${PROJECT_NAME}-frontlist PROPERTIES TIMEOUT 7200)

  # add_coal_test(sphere_capsule sphere_capsule.cpp)
  add_coal_test(capsule_capsule capsule_capsule.cpp)
  add_coal_test(box_box_distance box_box_distance.cpp)
  add_coal_test(box_box_collision box_box_collision.cpp)
  add_coal_test(simple simple.cpp)
  add_coal_test(capsule_box_1 capsule_box_1.cpp)
  add_coal_test(capsule_box_2 capsule_box_2.cpp)
  add_coal_test(obb obb.cpp)
  add_coal_test(convex convex.cpp)

  add_coal_test(bvh_models bvh_models.cpp)
  add_coal_test(collision_node_asserts collision_node_asserts.cpp)
  add_coal_test(hfields hfields.cpp)

  add_coal_test(profiling profiling.cpp)

  add_coal_test(gjk gjk.cpp)
  add_coal_test(accelerated_gjk accelerated_gjk.cpp)
  add_coal_test(gjk_convergence_criterion gjk_convergence_criterion.cpp)
  if(COAL_HAS_OCTOMAP)
    add_coal_test(octree octree.cpp)
  endif(COAL_HAS_OCTOMAP)

  add_coal_test(serialization serialization.cpp)

  add_coal_test(alloca alloca.cpp)

  # Broadphase
  add_coal_test(broadphase broadphase.cpp)
  set_tests_properties(${PROJECT_NAME}-broadphase PROPERTIES WILL_FAIL TRUE)
  add_coal_test(broadphase_dynamic_AABB_tree broadphase_dynamic_AABB_tree.cpp)
  add_coal_test(broadphase_collision_1 broadphase_collision_1.cpp)
  add_coal_test(broadphase_collision_2 broadphase_collision_2.cpp)

  ## Benchmark
  set(test_benchmark_target ${PROJECT_NAME}-test-benchmark)
  add_executable(${test_benchmark_target} benchmark.cpp)
  set_standard_output_directory(${test_benchmark_target})
  target_link_libraries(
    ${test_benchmark_target}
    PUBLIC ${utility_target} Boost::filesystem ${PROJECT_NAME}
  )
endif()

## Python tests
if(BUILD_PYTHON_INTERFACE)
  add_subdirectory(python_unit)
endif(BUILD_PYTHON_INTERFACE)

=== test/pixi_build/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22)
project(test_pixi_build)
find_package(coal REQUIRED)

=== test/python_unit/CMakeLists.txt ===
set(
  ${PROJECT_NAME}_PYTHON_TESTS
  geometric_shapes
  api
  collision
  collision_manager
  pickling
)

if(COAL_PYTHON_NANOBIND)
  set(PYTHON_BINDINGS_BINARY_DIR "python-nb")
else()
  set(PYTHON_BINDINGS_BINARY_DIR "python")
endif()

message(
  STATUS
  "  Python tests will be run with Python executable at ${Python_EXECUTABLE}"
)

add_dependencies(build_tests ${PROJECT_NAME}_python)
foreach(TEST ${${PROJECT_NAME}_PYTHON_TESTS})
  ADD_PYTHON_UNIT_TEST(
    "${PROJECT_NAME}-py-${TEST}"
    "test/python_unit/${TEST}.py"
    ${PYTHON_BINDINGS_BINARY_DIR}
  )
endforeach()

=== cmake/_unittests/python/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22)

# These variables have to be defined before running SETUP_PROJECT
set(PROJECT_NAME jrl-cmakemodules-python)
set(PROJECT_VERSION 0.0.0)
set(PROJECT_DESCRIPTION "JRL CMake module - python")
set(PROJECT_URL http://jrl-cmakemodules.readthedocs.io)

include(../macros.cmake)

include(../../base.cmake)
include(../../python.cmake)

COMPUTE_PROJECT_ARGS(PROJECT_ARGS)
project(${PROJECT_NAME} ${PROJECT_ARGS})
FINDPYTHON()

check_exist_variable(PYTHON_SITELIB "")

PYTHON_INSTALL_ON_SITE(jrl_cmakemodule python.py)

=== debian/changelog ===
ros-one-coal (3.0.2-423jammy.20260227.2040) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Joseph Mirabel <jmirabel@laas.fr>  Fri, 27 Feb 2026 20:40:26 +0000

=== debian/control ===
Source: ros-one-coal
Section: misc
Priority: optional
Maintainer: Joseph Mirabel <jmirabel@laas.fr>
Build-Depends: debhelper (>= 9.0.0), cmake, doxygen, git, libassimp-dev, libboost-all-dev, libeigen3-dev, liboctomap-dev, python3-dev, python3-lxml, python3-numpy, ros-one-eigenpy, ros-one-jrl-cmakemodules
Homepage: https://github.com/coal-library/coal
Standards-Version: 3.9.2

Package: ros-one-coal
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libassimp-dev, libboost-all-dev, libeigen3-dev, liboctomap-dev, python3-dev, python3-numpy, ros-one-catkin, ros-one-eigenpy
Description: An extension of the Flexible Collision Library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/one/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_configure -- \
		-DFETCHCONTENT_FULLY_DISCONNECTED=OFF \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/one" \
		-DCMAKE_PREFIX_PATH="/opt/ros/one" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-one-coal//opt/ros/one/lib/:$(CURDIR)/debian/ros-one-coal//opt/ros/one/lib/${DEB_HOST_MULTIARCH}

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_install

## ros-one-coal 3.0.2-423noble.20260227.2041

=== debian/changelog ===
ros-one-coal (3.0.2-423noble.20260227.2041) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Joseph Mirabel <jmirabel@laas.fr>  Fri, 27 Feb 2026 20:41:38 +0000
